import 'package:flutter/material.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';

class CustomListingWidget extends StatefulWidget {
  CustomListingParam params;

  Function(bool) onImgPress;
  Function(bool) onBtnPress;
  Function(bool) onCardPress;

  // CustomListingWidget({this.params, this.onImgPress, this.onBtnPress, this.onCardPress});
  CustomListingWidget({
    this.params,
    this.onImgPress,
    this.onBtnPress,
    this.onCardPress,
  });

  @override
  _CustomListingWidgetState createState() => _CustomListingWidgetState();
}

class _CustomListingWidgetState extends State<CustomListingWidget> {
  @override
  Widget build(BuildContext context) {
    return Container(
      child: CardItem(),
    );
  }

  Widget CardItem() {
    return InkWell(
      onTap: () {
        return (widget.onCardPress != null) ? widget.onCardPress(true) : null;
      },
      child: Card(
        elevation: 3,
        child: Column(
          children: [
            InkWell(
              onTap: () {
                return (widget.onImgPress != null) ? widget.onImgPress(true) : null;
              },
              child: Image(
                height: (widget.params.imgHeight != null) ? widget.params.imgHeight : 120.0,
                image: NetworkImage(widget.params.imgUrl),
                fit: BoxFit.cover,
              ),
            ),
            SizedBox(
              height: 10,
            ),
            Container(
              width: double.infinity,
              padding: EdgeInsets.only(left: 5, right: 5),
              child: Text(
                (widget.params.title != null) ? widget.params.title : "",
                textAlign: TextAlign.center,
                style: TextStyle(
                    fontSize: (widget.params.titlefontSize != null) ? widget.params.titlefontSize : 16.0,
                    color: (widget.params.titlefontColor != null)
                        ? widget.params.titlefontColor
                        : Colors.blueAccent.shade400,
                    fontFamily:
                        (widget.params.titlefontFamily != null) ? widget.params.titlefontFamily : 'Roboto'),
              ),
            ),
            SizedBox(
              height: 5,
            ),
            Container(
              width: double.infinity,
              padding: EdgeInsets.only(left: 5, right: 5),
              child: Text(
                (widget.params.subTitle != null) ? widget.params.subTitle : "",
                textAlign: TextAlign.center,
                style: TextStyle(
                    fontSize:
                        (widget.params.subTitlefontSize != null) ? widget.params.subTitlefontSize : 16.0,
                    color: (widget.params.subTitlefontColor != null)
                        ? widget.params.subTitlefontColor
                        : Colors.black,
                    fontFamily: (widget.params.subTitlefontFamily != null)
                        ? widget.params.subTitlefontFamily
                        : 'Roboto'),
              ),
            ),
            SizedBox(
              height: 5,
            ),
            Container(
                width: MediaQuery.of(context).size.width,
                height: (widget.params.subBtnHeight != null) ? widget.params.subBtnHeight : 40.0,
                margin: EdgeInsets.symmetric(horizontal: 20),
                // padding: EdgeInsets.all(5.0),
                decoration: BoxDecoration(
                  border: Border.all(
                      color: (widget.params.subBtnborderColor != null)
                          ? widget.params.subBtnborderColor
                          : Colors.blueAccent.shade400),
                  borderRadius: BorderRadius.circular(
                      (widget.params.subBtnHeight != null) ? widget.params.subBtnHeight / 2 : 20),
                ),
                child: InkWell(
                  onTap: () {
                    return (widget.onBtnPress != null) ? widget.onBtnPress(true) : null;
                  },
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      Icon(
                        (widget.params.icon != null) ? widget.params.icon : Icons.shopping_cart,
                        color: (widget.params.iconColor != null)
                            ? widget.params.iconColor
                            : Colors.blueAccent.shade400,
                        size: (widget.params.iconsize != null) ? widget.params.iconsize : 15.0,
                      ),
                      SizedBox(width: 5),
                      Text(
                        (widget.params.subBtnText != null) ? widget.params.subBtnText : "Add to Cart",
                        style: TextStyle(
                            fontSize: (widget.params.subBtnfontSize != null)
                                ? widget.params.subBtnfontSize
                                : 15.0,
                            color: (widget.params.subBtnfontColor != null)
                                ? widget.params.subBtnfontColor
                                : Colors.blueAccent.shade400,
                            fontFamily: (widget.params.subBtnfontFamily != null)
                                ? widget.params.subBtnfontFamily
                                : 'Roboto'),
                      )
                    ],
                  ),
                )),
            SizedBox(
              height: 5,
            ),
          ],
        ),
      ),
    );
  }
}
