import 'package:flutter/material.dart';
class Dialogs {
  static Future<void> showLoadingDialog({BuildContext context, GlobalKey key, String msg, Color backgroundColor, Color progressTextColor}) async {
    return showDialog<void>(
        context: context,
        barrierDismissible: false,
        builder: (BuildContext context) {
          Future.delayed(Duration(seconds: 3), () {
            Navigator.of(context).pop();
          });
          return WillPopScope(
              onWillPop: () async => false,
              child:
                  SimpleDialog(key: key, backgroundColor: backgroundColor, elevation: 5, children: <Widget>[
                Center(
                  child: Column(children: [
                    CircularProgressIndicator(color: progressTextColor),
                    SizedBox(
                      height: 10,
                    ),
                    Text(
                      (msg!='null')?msg:'Saving your response !!',
                      style: TextStyle(color: progressTextColor),
                    )
                  ]),
                )
              ]));
        });
  }
}
