import 'package:flutter/cupertino.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';
import 'package:flutter/material.dart';

PreferredSize appbar(AppBarParams appBarParams) {
  return (appBarParams.drawerPosition == 'Right')
      ? PreferredSize(
          preferredSize: const Size.fromHeight(50),
          child: AppBar(
            automaticallyImplyLeading: false,
            titleSpacing: 0,
            elevation:
                (appBarParams.elevation != null) ? appBarParams.elevation : 0,
            shadowColor: (appBarParams.shadowColor != null)
                ? appBarParams.shadowColor
                : Colors.transparent,
            backgroundColor: (appBarParams.backgroundColor != null)
                ? appBarParams.backgroundColor
                : Colors.transparent,
            shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.vertical(
                bottom: Radius.circular((appBarParams.bottomRadius != 0)
                    ? appBarParams.bottomRadius
                    : 0),
              ),
            ),
            //leading:
            title: Padding(
              padding: EdgeInsets.only(
                bottom: (appBarParams.bottomPadImage != null)
                    ? appBarParams.bottomPadImage
                    : 0,
                top: (appBarParams.topPadImage != null)
                    ? appBarParams.topPadImage
                    : 0,
                left: (appBarParams.leftPadImage != null)
                    ? appBarParams.leftPadImage
                    : 0,
                right: (appBarParams.rightPadImage != null)
                    ? appBarParams.rightPadImage
                    : 0,
              ),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.start,
                children: [
                  (appBarParams.imageUrl != 'null')
                      ? Container(
                          height: 50,
                          width: 50,
                          child:
                              Image(image: NetworkImage(appBarParams.imageUrl)),
                        )
                      : SizedBox.shrink(),
                  (appBarParams.imageUrl != 'null')
                      ? SizedBox(
                          width: 10,
                        )
                      : SizedBox.shrink(),
                  (appBarParams.text != 'null')
                      ? Flexible(
                          child: Text(appBarParams.text,
                              style: TextStyle(color: appBarParams.textColor)))
                      : SizedBox.shrink(),
                  (appBarParams.pramPreviousPage != 'null'&& appBarParams.pramPreviousPage.trim().isNotEmpty)
                      ? SizedBox(
                    width: 10,
                  )
                      : SizedBox.shrink(),
                  (appBarParams.pramPreviousPage!='null'&& appBarParams.pramPreviousPage.trim().isNotEmpty)?
                  Flexible(
                      child: Text(appBarParams.pramPreviousPage,
                          style: TextStyle(color: appBarParams.textColor)))
                      : SizedBox.shrink(),
                ],
              ),
            ),
            actions: [
              (appBarParams.icon1 != null)
                  ? SizedBox(
                      width: 10,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon1 != null)
                  ? Icon(
                      appBarParams.icon1,
                      color: appBarParams.iconColor ?? Colors.grey,
                      size: 18,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon2 != null)
                  ? SizedBox(
                      width: 10,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon2 != null)
                  ? Icon(
                      appBarParams.icon2,
                      color: appBarParams.iconColor ?? Colors.grey,
                      size: 18,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon3 != null)
                  ? SizedBox(
                      width: 10,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon3 != null)
                  ? Icon(
                      appBarParams.icon3,
                      color: appBarParams.iconColor ?? Colors.grey,
                      size: 18,
                    )
                  : SizedBox.shrink(),
              SizedBox(
                width: 10,
              ),
              Builder(
                  builder: (context) => FlatButton(
                        onPressed: () => Scaffold.of(context).openEndDrawer(),
                        child: Container(
                          height: 20,
                          width: 20,
                          decoration: BoxDecoration(
                              borderRadius: BorderRadius.circular(3.0),
                              color: Colors.transparent,
                              boxShadow: []),
                          child: Center(
                            child: Image(
                              image:NetworkImage('http://23.96.94.185:9002/images/1635761321593-drawer-icon.png'),
                            ),
                          ),
                        ),
                      )),
            ],
          ),
        )
      : PreferredSize(
          preferredSize: const Size.fromHeight(50),
          child: AppBar(
            titleSpacing: 0,
            elevation:
                (appBarParams.elevation != null) ? appBarParams.elevation : 0,
            shadowColor: (appBarParams.shadowColor != null)
                ? appBarParams.shadowColor
                : Colors.transparent,
            backgroundColor: (appBarParams.backgroundColor != null)
                ? appBarParams.backgroundColor
                : Colors.transparent,
            shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.vertical(
                bottom: Radius.circular((appBarParams.bottomRadius != 0)
                    ? appBarParams.bottomRadius
                    : 0),
              ),
            ),
            leading: Builder(
                builder: (context) => FlatButton(
                      onPressed: () => Scaffold.of(context).openDrawer(),
                      child: Container(
                        height: 20,
                        width: 20,
                        decoration: BoxDecoration(
                            borderRadius: BorderRadius.circular(3.0),
                            color: Colors.transparent,
                            boxShadow: []),
                        child: Center(
                          child: Image(
                            image: NetworkImage('http://23.96.94.185:9002/images/1635761321593-drawer-icon.png'),
                          ),
                        ),
                      ),
                    )),
            title: Padding(
              padding: EdgeInsets.only(
                bottom: (appBarParams.bottomPadImage != null)
                    ? appBarParams.bottomPadImage
                    : 0,
                top: (appBarParams.topPadImage != null)
                    ? appBarParams.topPadImage
                    : 0,
                left: (appBarParams.leftPadImage != null)
                    ? appBarParams.leftPadImage
                    : 0,
                right: (appBarParams.rightPadImage != null)
                    ? appBarParams.rightPadImage
                    : 0,
              ),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.start,
                children: [
                  (appBarParams.imageUrl != 'null')
                      ? Container(
                          height: 50,
                          width: 50,
                          child:
                              Image(image: NetworkImage(appBarParams.imageUrl)),
                        )
                      : SizedBox.shrink(),
                  (appBarParams.imageUrl != 'null')
                      ? SizedBox(
                          width: 10,
                        )
                      : SizedBox.shrink(),
                  (appBarParams.text != 'null')
                      ? Flexible(
                          child: Text(appBarParams.text,
                              style: TextStyle(color: appBarParams.textColor)))
                      : SizedBox.shrink(),
                  (appBarParams.pramPreviousPage != 'null'&& appBarParams.pramPreviousPage.trim().isNotEmpty)
                      ? SizedBox(
                    width: 10,
                  )
                      : SizedBox.shrink(),
                  (appBarParams.pramPreviousPage!='null'&& appBarParams.pramPreviousPage.trim().isNotEmpty)?
                  Flexible(
                      child: Text(appBarParams.pramPreviousPage,
                          style: TextStyle(color: appBarParams.textColor)))
                      : SizedBox.shrink(),
                ],
              ),
            ),
            actions: [
              (appBarParams.icon1 != null)
                  ? SizedBox(
                      width: 10,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon1 != null)
                  ? Icon(
                      appBarParams.icon1,
                      color: appBarParams.iconColor ?? Colors.grey,
                      size: 18,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon2 != null)
                  ? SizedBox(
                      width: 10,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon2 != null)
                  ? Icon(
                      appBarParams.icon2,
                      color: appBarParams.iconColor ?? Colors.grey,
                      size: 18,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon3 != null)
                  ? SizedBox(
                      width: 10,
                    )
                  : SizedBox.shrink(),
              (appBarParams.icon3 != null)
                  ? Icon(
                      appBarParams.icon3,
                      color: appBarParams.iconColor ?? Colors.grey,
                      size: 18,
                    )
                  : SizedBox.shrink(),


              SizedBox(
                width: 25,
              ),
            ],
          ),
        );
}
