import 'package:flutter/material.dart';
class NewEventAlert extends StatefulWidget {
  final DateTime dateTime;
  final Function(String,String,TimeOfDay,TimeOfDay) event_val;
  NewEventAlert({@required this.dateTime ,@required this.event_val});
  @override
  _NewEventAlertState createState() => _NewEventAlertState();
}

class _NewEventAlertState extends State<NewEventAlert> {
  TextEditingController eventController = new TextEditingController();
  TextEditingController decriptionController = new TextEditingController();
  TimeOfDay time = TimeOfDay(hour: 9, minute: 0);
  TimeOfDay timeEnd = TimeOfDay(hour: 9, minute: 0);
  @override
  Widget build(BuildContext context) {
    return Container(
      child: (widget.dateTime.compareTo(DateTime(DateTime.now().year, DateTime.now().month, DateTime.now().day))>=0)?
      AlertDialog(
        clipBehavior: Clip.antiAlias,
        shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(10)),
        title: Row(
          mainAxisAlignment: MainAxisAlignment
              .spaceBetween,
          children: [
            Text('Add Event'),
          ],
        ),
        content: Column(
          mainAxisSize: MainAxisSize.min,
          children: [
            TextField(
              controller: eventController,
              decoration: InputDecoration(
                  prefixIcon: Icon(Icons.event,size: 20,),
                  hintText: "Event-Name",
                  border: OutlineInputBorder(
                    borderRadius: BorderRadius.circular(5),
                  )
              ),
            ),
            SizedBox(height: 8,),
            TextField(
              controller: decriptionController,
              decoration: InputDecoration(
                  prefixIcon: Icon(Icons.description,size: 20,),
                  hintText: "Event-Description",
                  border: OutlineInputBorder(
                    borderRadius: BorderRadius.circular(5),
                  )
              ),
            ),
            SizedBox(height: 15,),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                ElevatedButton(
                  style: ButtonStyle(
                      backgroundColor: MaterialStateProperty.all(Colors.blueGrey),
                      shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                          RoundedRectangleBorder(
                              borderRadius: BorderRadius.circular(5),
                              side: BorderSide(color: Colors.blueGrey, width: 1.0)))),
                  child: Text(getText()),
                  onPressed: () {
                    pickTime(context);
                    //Navigator.pop(context);
                  },
                ),
                ElevatedButton(
                  style: ButtonStyle(
                      backgroundColor: MaterialStateProperty.all(Colors.blueGrey),
                      shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                          RoundedRectangleBorder(
                              borderRadius: BorderRadius.circular(5),
                              side: BorderSide(color: Colors.blueGrey, width: 1.0)))),
                  child: Text( getendText()),
                  onPressed: () {
                    pickendTime(context);
                    //Navigator.pop(context);
                  },
                ),
              ],
            )
          ],
        ),
        actions: [
          ElevatedButton(
            style: ButtonStyle(
                backgroundColor: MaterialStateProperty.all(Colors.green),
                shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                    RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(10),
                        side: BorderSide(color: Colors.green, width: 1.0)))),
            child: Text('Yes'),
            onPressed: () {
              widget.event_val(eventController.text,decriptionController.text,time,timeEnd);
              Navigator.pop(context);
            },
          ),
          ElevatedButton(
            style: ButtonStyle(
                backgroundColor: MaterialStateProperty.all(Colors.red),
                shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                    RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(10),
                        side: BorderSide(color: Colors.red, width: 1.0)))),
            child: Text('No'),
            onPressed: () {
              /* widget.onsavesd("No");*/
              Navigator.pop(context);
            },
          ),
        ],
      ):
      AlertDialog(
        clipBehavior: Clip.antiAlias,
        shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(10)),
        title: Text('Can not add event as day elapsed !!'),
        actions: [
          ElevatedButton(
            style: ButtonStyle(
                backgroundColor: MaterialStateProperty.all(Colors.red),
                shape: MaterialStateProperty.all<RoundedRectangleBorder>(
                    RoundedRectangleBorder(
                        borderRadius: BorderRadius.circular(10),
                        side: BorderSide(color: Colors.red, width: 1.0)))),
            child: Text('Dismiss'),
            onPressed: () {
              Navigator.pop(context);
            },
          ),
        ],
      ),
    );
  }

  Future pickTime(BuildContext context) async {
    final initialTime = TimeOfDay(hour: 9, minute: 0);
    final newTime = await showTimePicker(
      context: context,
      initialTime: time.hour==null ? initialTime:time,
    );

    if (newTime == null) return;
    setState(() {
      time = newTime;
      print(time.hour.toString());
    });
  }
  String getText(){
    if(time.hour==null){
      return 'Start-Time';
    }
    else{
      return '${time.hour}:${time.minute}';
    }
  }


  Future pickendTime(BuildContext context) async {
    final initialTime = TimeOfDay(hour: 9, minute: 0);
    final newTime = await showTimePicker(
      context: context,
      initialTime: timeEnd.hour==null ? initialTime:timeEnd,
    );

    if (newTime == null) return;
    setState(() {
      timeEnd = newTime;
      print(timeEnd.hour.toString());
    });
  }
  String getendText(){
    if(timeEnd.hour==null){
      return 'End-Time';
    }
    else{
      return '${timeEnd.hour}:${timeEnd.minute}';
    }
  }

}
