import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:rapid_widgets_library/custom-multiflipcard.dart';
import 'package:charts_flutter/flutter.dart' as charts;

class ImageTextCard {
  String imagePath;
  Map keyValueMap;
  double elevation;
  Color shadowColor;
  double borderRadius;

  double textPadding;
  Color backgroundColor;
  List<Widget> text;
  ImageTextCard(
      {this.imagePath,
      this.elevation,
      this.shadowColor,
      this.borderRadius,
      this.textPadding,
      this.backgroundColor,
      this.text});
}

class ContactCardParameters {
  final String urlImage;
  final List<Map<String, IconData>> items;
  final Color backgroundColorOuterCard;
  final double elevation;
  final double elevationInnerCard;
  final Color textColor;
  final Color iconColor;
  final int flexImage;
  final int flexText;
  final double circleAvatarRadius;
  final double iconSize;
  final double fontSize;
  final double borderRadius;
  final double paddingOuter;
  final double paddingInner;
  final double paddingTop;
  final double paddingBoottom;
  final double paddingRight;
  final double paddingLeft;
  final bool imgRight;
  final Color backgroundColorInnerCard;

  ContactCardParameters(
      {this.urlImage,
      this.items,
      this.paddingBoottom,
      this.paddingLeft,
      this.paddingRight,
      this.paddingTop,
      this.backgroundColorInnerCard,
      this.backgroundColorOuterCard,
      this.elevationInnerCard,
      this.circleAvatarRadius,
      this.elevation,
      this.iconSize,
      this.textColor,
      this.iconColor,
      this.flexImage,
      this.flexText,
      this.fontSize,
      this.borderRadius,
      this.paddingOuter,
      this.paddingInner,
      this.imgRight = false});
}

class EventCalendar {
  final double height;
  final double width;
  EventCalendar({this.height, this.width});
}

///Widget Class
class TileData {
  ///parameter
  Widget leading;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  Widget trailing;

  ///parameter
  bool enabled;

  ///parameter
  bool selected;

  ///Constructor
  TileData(
      {this.leading,
      this.title,
      this.subtitle,
      this.trailing,
      this.enabled = true,
      this.selected = false});
}

///Widget Class
class ListTileParameters {
  ///parameter
  final bool isThreeLine;

  ///parameter
  final bool dense;

  ///parameter
  final EdgeInsetsGeometry contentPadding;

  ///parameter
  final GestureTapCallback onTap;

  ///parameter
  final GestureLongPressCallback onLongPress;

  ListTileParameters({
    this.isThreeLine = false,
    this.dense,
    this.contentPadding,
    this.onTap,
    this.onLongPress,
  });
}

///Widget Class
class CustomDividerParameters {
  ///parameter
  final double height;

  ///parameter
  final double thickness;

  ///parameter
  final double indent;

  ///parameter
  final double endIndent;

  ///parameter
  final Color color;

  const CustomDividerParameters({
    this.height,
    this.thickness,
    this.indent,
    this.endIndent,
    this.color,
  });
}

///Widget Class
class CustomToolTipparams {
  ///parameter
  final String message;

  ///parameter
  final Widget child;

  ///parameter
  final double height;

  ///parameter
  final EdgeInsetsGeometry padding;

  ///parameter
  final EdgeInsetsGeometry margin;

  ///parameter
  final double verticalOffset;

  ///parameter
  final bool preferBelow;

  ///parameter
  final bool excludeFromSemantics;

  ///parameter
  final Decoration decoration;

  ///parameter
  final TextStyle textStyle;

  ///parameter
  final Duration waitDuration;

  ///parameter
  final Duration showDuration;

  const CustomToolTipparams(
      {this.message,
      this.child,
      this.height,
      this.padding,
      this.margin,
      this.verticalOffset,
      this.preferBelow,
      this.excludeFromSemantics,
      this.decoration,
      this.textStyle,
      this.waitDuration,
      this.showDuration});
}

///Widget Class
class CustomLinearProgressBarParameters {
  ///parameter
  final double value;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Animation<Color> valueColor;

  ///parameter
  final String semanticsLabel;

  ///parameter
  final String semanticsValue;

  const CustomLinearProgressBarParameters({
    Key key,
    this.value,
    this.backgroundColor,
    this.valueColor,
    this.semanticsLabel,
    this.semanticsValue,
  });
}

///Widget Class
class CustomCircularProgressIndicatorParameters {
  ///parameter
  final double value;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Color valueColor;

  ///parameter
  final String semanticsLabel;

  ///parameter
  final String semanticsValue;

  CustomCircularProgressIndicatorParameters(
      {this.value,
      this.backgroundColor,
      this.valueColor,
      this.semanticsLabel,
      this.semanticsValue});
}

///Widget Class
class Products {
  ///parameter
  String imagepath;

  ///parameter
  String text1;

  ///parameter
  String text2;

  ///parameter
  String text3;

  ///parameter
  String text4;

  ///parameter

  Products(this.imagepath, this.text1, this.text2, this.text3, this.text4);
}

class CardText {
  IconData icon;
  String label;
  String text;
  double fontSize;
  Color textColor;
  String fontFamily;
  CardText(
      {this.icon,
      this.label,
      this.text,
      this.fontFamily,
      this.fontSize,
      this.textColor});
}

///Widget Class
class ListItems {
  ///parameter
  IconData icon;

  ///parameter
  String text1;

  ListItems(this.icon, this.text1);
}

///Widget Class
class User {
  ///parameter
  String imagepath;

  ///parameter
  String username;

  ///parameter
  String useremailid;

  ///parameter
  FontWeight fontWeight;

  ///parameter
  double fontSize;

  ///parameter
  Color fontColor;

  ///parameter
  Color headerColor;

  ///parameter

  User(this.imagepath, this.username, this.useremailid, this.fontColor,
      this.fontWeight, this.fontSize, this.headerColor);
}

///Widget Class
class VTabBarProducts {
  ///parameter
  String text;

  ///parameter
  IconData icons;

  ///parameter
  Widget widget;

  VTabBarProducts(this.text, this.icons, this.widget);
}

///Widget Class
class ButtonBarParameters {
  ///parameter
  List<ButtonBarList> list;

  ///parameter
  Color buttonbgColor;

  ///parameter
  Color textColor;

  ///parameter
  Color disabledTextColor;

  ///parameter
  double highlightElevation;

  ///parameter
  double elevation;

  ///parameter
  double disabledElevation;

  ///parameter
  Color hoverColor;

  ///parameter
  Color borderColor;

  ///parameter
  double borderWidth;

  ///parameter
  Color focusColor;

  ///parameter
  double buttonBorderRadius;

  ///parameter
  ButtonBarParameters(
      {this.list,
      this.buttonbgColor,
      this.textColor,
      this.disabledTextColor,
      this.highlightElevation,
      this.elevation,
      this.disabledElevation,
      this.hoverColor,
      this.borderColor,
      this.borderWidth,
      this.focusColor,
      this.buttonBorderRadius});
}

///Widget Class
class ButtonBarList {
  ///parameter
  String text;

  ///parameter
  Icon icons;
  ButtonBarList(this.text, this.icons);
}

///Widget Class
class TabBarViewParameters {
  ///parameter
  Color backgroundColor;

  ///parameter
  Color labelColor;

  ///parameter
  Color indicatorColor;

  ///parameter
  Color unselectedLabelColor;

  ///parameter
  Color boxShadowColor;

  ///parameter
  Color borderColor;

  ///parameter
  double borderWidth;

  ///parameter
  Color boxColor;

  ///parameter
  BorderRadiusGeometry borderRadius;

  ///parameter
  List<TabBarProducts> listTabs;

  TabBarViewParameters({
    this.backgroundColor,
    this.labelColor,
    this.indicatorColor,
    this.unselectedLabelColor,
    this.boxShadowColor,
    this.borderColor,
    this.borderWidth,
    this.boxColor,
    this.borderRadius,
    this.listTabs,
  });
}

///Widget Class
class TabBarProducts {
  ///parameter
  String text;

  ///parameter
  Icon icons;

  ///parameter
  Widget widget;

  TabBarProducts(this.text, this.icons, this.widget);
}

///Widget Class
class TabBarParameters {
  ///parameter
  Color backgroundColor;

  ///parameter
  Color labelColor;

  ///parameter
  Color indicatorColor;

  ///parameter
  Color unselectedLabelColor;

  ///parameter
  Color boxShadowColor;

  ///parameter
  Color borderColor;

  ///parameter
  double borderWidth;

  ///parameter
  Color boxColor;

  ///parameter
  BorderRadiusGeometry borderRadius;

  ///parameter
  List<TabBarList> tablist;

  TabBarParameters({
    this.backgroundColor,
    this.labelColor,
    this.indicatorColor,
    this.unselectedLabelColor,
    this.boxShadowColor,
    this.borderColor,
    this.borderWidth,
    this.boxColor,
    this.borderRadius,
    this.tablist,
  });
}

///Widget Class
class TabBarList {
  ///parameter
  String text;

  ///parameter
  Icon icons;

  ///parameter
  TabBarList(this.text, this.icons);
}

///Widget Class
class AppBarParameters {
  ///parameter
  final Widget leading;

  ///parameter
  final bool automaticallyImplyLeading;

  ///parameter
  final Widget title;

  ///parameter
  final List<Widget> actions;

  ///parameter
  final Widget flexibleSpace;

  ///parameter
  PreferredSizeWidget bottom;

  ///parameter
  final double elevation;

  ///parameter
  final ShapeBorder shape;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Brightness brightness;

  ///parameter
  final IconThemeData iconTheme;

  ///parameter
  final IconThemeData actionsIconTheme;

  ///parameter
  final TextTheme textTheme;

  ///parameter
  final bool primary;

  ///parameter
  final bool centerTitle;

  ///parameter
  final bool excludeHeaderSemantics;

  ///parameter
  final double titleSpacing;

  ///parameter
  final double toolbarOpacity;

  ///parameter
  final double bottomOpacity;

  ///parameter
  Widget searchBar;

  AppBarParameters(
      {this.leading,
      this.automaticallyImplyLeading,
      this.title,
      this.actions,
      this.flexibleSpace,
      this.bottom,
      this.elevation,
      this.shape,
      this.backgroundColor,
      this.brightness,
      this.iconTheme,
      this.actionsIconTheme,
      this.textTheme,
      this.primary,
      this.centerTitle,
      this.excludeHeaderSemantics,
      this.titleSpacing,
      this.toolbarOpacity,
      this.bottomOpacity,
      this.searchBar});
}

///Widget Class
class BottomNavBarParameters {
  ///parameter
  final List<BottomNavigationBarItem> items;

  ///parameter
  final ValueChanged onTap;

  ///parameter
  final int currentIndex;

  ///parameter
  final double elevation;

  ///parameter
  final BottomNavigationBarType type;

  ///parameter
  final Color fixedColor;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final double iconSize;

  ///parameter
  final Color selectedItemColor;

  ///parameter
  final Color unselectedItemColor;

  ///parameter
  final IconThemeData selectedIconTheme;

  ///parameter
  final IconThemeData unselectedIconTheme;

  ///parameter
  final double selectedFontSize;

  ///parameter
  final double unselectedFontSize;

  ///parameter
  final TextStyle selectedLabelStyle;

  ///parameter
  final TextStyle unselectedLabelStyle;

  ///parameter
  final bool showSelectedLabels;

  ///parameter
  final bool showUnselectedLabels;

  BottomNavBarParameters({
    this.items,
    this.onTap,
    this.currentIndex,
    this.elevation,
    this.type,
    this.fixedColor,
    this.backgroundColor,
    this.iconSize,
    this.selectedItemColor,
    this.unselectedItemColor,
    this.selectedIconTheme,
    this.unselectedIconTheme,
    this.selectedFontSize,
    this.unselectedFontSize,
    this.selectedLabelStyle,
    this.unselectedLabelStyle,
    this.showSelectedLabels,
    this.showUnselectedLabels,
  });
}

///Widget Class
class SliverAppBarParameters {
  ///parameter
  final Widget leading;

  ///parameter
  final bool automaticallyImplyLeading;

  ///parameter
  final Widget title;

  ///parameter
  final List<Widget> actions;

  ///parameter
  final Widget flexibleSpace;

  ///parameter
  PreferredSizeWidget bottom;

  ///parameter
  final double elevation;

  ///parameter
  final bool forceElevated;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Brightness brightness;

  ///parameter
  final IconThemeData iconTheme;

  ///parameter
  final IconThemeData actionsIconTheme;

  ///parameter
  final TextTheme textTheme;

  ///parameter
  final bool primary;

  ///parameter
  final bool centerTitle;

  ///parameter
  final bool excludeHeaderSemantics;

  ///parameter
  final double titleSpacing;

  ///parameter
  final double expandedHeight;

  ///parameter
  final bool floating;

  ///parameter
  final bool pinned;

  ///parameter
  final bool snap;

  ///parameter
  final bool stretch;

  ///parameter
  final double stretchTriggerOffset;

  ///parameter
  final AsyncCallback onStretchTrigger;

  ///parameter
  final ShapeBorder shape;

  SliverAppBarParameters(
      {this.leading,
      this.automaticallyImplyLeading,
      this.title,
      this.actions,
      this.flexibleSpace,
      this.bottom,
      this.elevation,
      this.forceElevated,
      this.backgroundColor,
      this.brightness,
      this.iconTheme,
      this.actionsIconTheme,
      this.textTheme,
      this.primary,
      this.centerTitle,
      this.excludeHeaderSemantics,
      this.titleSpacing,
      this.expandedHeight,
      this.floating,
      this.pinned,
      this.snap,
      this.stretch,
      this.stretchTriggerOffset,
      this.onStretchTrigger,
      this.shape});
}

///Widget Class
class CarouselClass {
  ///parameter
  Widget widget;

  ///parameter
  String text1;

  ///parameter
  Animation animation;

  CarouselClass({this.widget, this.text1, this.animation});
}

///Widget Class
class CarouselClass1 {
  ///parameter
  Widget widget;

  ///parameter
  String text1;

  ///parameter
  Cubic animation;

  ///parameter
  Duration animationDuration;

  CarouselClass1(
      {this.widget, this.text1, this.animation, this.animationDuration});
}

///Widget Class
class CustomcompositeCardParameters {
  ///parameter
  int flexColumn1;

  ///parameter
  int flexColumn2;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  List<Widget> leftHandWidgets;

  ///parameter
  List<Widget> rightHandWidgets;

  ///parameter
  double margin;

  ///parameter
  double elevation;

  ///parameter
  Color cardColor;

  ///parameter
  Color shadowColor;

  ///parameter
  double shadowSpread;

  ///parameter
  double textSpacing;

  CustomcompositeCardParameters(
      {this.flexColumn1,
      this.flexColumn2,
      this.title,
      this.subtitle,
      this.leftHandWidgets,
      this.rightHandWidgets,
      this.margin,
      this.elevation,
      this.cardColor,
      this.shadowColor,
      this.shadowSpread,
      this.textSpacing});
}

///Widget Class
class SliderParameters {
  ///parameter
  final String label;

  ///parameter
  final Color activeColor;

  ///parameter
  final int divisions;

  ///parameter
  final Color inactiveColor;

  ///parameter
  final double max;

  ///parameter
  final double min;

  ///parameter
  final ValueChanged<double> onChanged;

  ///parameter
  final ValueChanged<double> onChangeEnd;

  ///parameter
  final ValueChanged<double> onChangeStart;

  ///parameter
  final SemanticFormatterCallback semanticFormatterCallback;

  ///parameter
  final double value;

  SliderParameters({
    Key key,
    this.label,
    this.activeColor,
    this.divisions,
    this.inactiveColor,
    this.max,
    this.min,
    this.onChanged,
    this.onChangeEnd,
    this.onChangeStart,
    this.semanticFormatterCallback,
    this.value,
  });
}

///Widget Class
class AlertDialogContents {
  ///parameter
  List<Widget> buttons;

  ///parameter
  String content;

  ///parameter
  Widget title;

  AlertDialogContents(this.buttons, this.content, this.title);
}

///Widget Class
class AlertDialogParameters {
  ///parameter
  final Widget title;

  ///parameter
  final EdgeInsetsGeometry titlePadding;

  ///parameter
  final TextStyle titleTextStyle;

  ///parameter
  final Widget content;

  ///parameter
  final EdgeInsetsGeometry contentPadding;

  ///parameter
  final TextStyle contentTextStyle;

  ///parameter
  final List<Widget> actions;

  ///parameter
  final EdgeInsetsGeometry actionsPadding;

  ///parameter
  final VerticalDirection actionsOverflowDirection;

  ///parameter
  final double actionsOverflowButtonSpacing;

  ///parameter
  final EdgeInsetsGeometry buttonPadding;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final double elevation;

  ///parameter
  final String semanticLabel;

  ///parameter
  final EdgeInsets insetPadding;

  ///parameter
  final Clip clipBehavior;

  ///parameter
  final ShapeBorder shape;

  ///parameter
  final bool scrollable;

  ///parameter
  final double height;

  ///parameter
  final double width;

  AlertDialogParameters({
    Key key,
    this.title,
    this.titlePadding,
    this.titleTextStyle,
    this.content,
    this.contentPadding = const EdgeInsets.fromLTRB(24.0, 20.0, 24.0, 24.0),
    this.contentTextStyle,
    this.actions,
    this.actionsPadding = EdgeInsets.zero,
    this.actionsOverflowDirection,
    this.actionsOverflowButtonSpacing,
    this.buttonPadding,
    this.backgroundColor,
    this.elevation,
    this.semanticLabel,
    this.insetPadding,
    this.clipBehavior = Clip.none,
    this.shape,
    this.scrollable = false,
    this.height,
    this.width,
  });
}

///Widget Class
class BottomSheetContents {
  ///parameter
  IconButton iconB;

  ///parameter
  String text1;

  BottomSheetContents(this.iconB, this.text1);
}

///Widget Class
class BottomSheetParameters {
  ///parameter
  final AnimationController animationController;

  ///parameter
  final bool enableDrag;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final double elevation;

  ///parameter
  final ShapeBorder shape;

  ///parameter
  final Clip clipBehavior;

  ///parameter
  final VoidCallback onClosing;

  ///parameter
  final WidgetBuilder builder;

  ///parameter
  final double itemExtent;

  ///parameter
  final double height;

  ///parameter
  final Color iconColor;

  ///parameter
  final Color fontColor;

  ///parameter
  final double contentSize;

  BottomSheetParameters(
      {Key key,
      this.animationController,
      this.enableDrag = true,
      this.backgroundColor,
      this.elevation,
      this.shape,
      this.clipBehavior,
      this.onClosing,
      this.builder,
      this.itemExtent,
      this.height,
      this.fontColor,
      this.iconColor,
      this.contentSize});
}

///Widget Class
class SwitchParameters {
  ///parameter
  final ImageProvider activeThumbImage;

  ///parameter
  final Color activeColor;

  ///parameter
  final Color activeTrackColor;

  ///parameter
  final Color focusColor;

  ///parameter
  final Color hoveColor;

  ///parameter
  final Color inactiveTrackColor;

  ///parameter
  final bool autofocus;

  ///parameter
  final FocusNode focusNode;

  ///parameter
  final ImageProvider inactiveThumbImage;

  ///parameter
  final MaterialTapTargetSize materialTapTargetSize;

  ///parameter
  final ImageErrorListener onActiveThumbImageError;

  ///parameter
  final ValueChanged<bool> onChanged;

  ///parameter
  final ImageErrorListener onInactiveThumbImageError;

  ///parameter
  final bool value;

  SwitchParameters({
    Key key,
    this.activeThumbImage,
    @required this.activeColor,
    this.materialTapTargetSize,
    this.focusNode,
    this.autofocus,
    this.onChanged,
    this.value,
    @required this.activeTrackColor,
    this.focusColor,
    this.hoveColor,
    this.inactiveThumbImage,
    this.inactiveTrackColor,
    this.onActiveThumbImageError,
    this.onInactiveThumbImageError,
  });
}

///Widget Class
class CustomImageContents {
  ///parameter
  final String src;

  ///parameter
  final Key key;

  ///parameter
  final double scale = 1.0;

  ///parameter
  final String semanticLabel;

  ///parameter
  final bool excludeFromSemantics;

  ///parameter
  final double width;

  ///parameter
  final double height;

  ///parameter
  final Color color;

  ///parameter
  final BlendMode colorBlendMode;

  ///parameter
  final BoxFit fit;

  ///parameter
  final AlignmentGeometry alignment;

  ///parameter
  final ImageRepeat repeat;

  ///parameter
  final Rect centerSlice;

  ///parameter
  final FilterQuality filterQuality;

  ///parameter
  final String imageType;

  final double outerAreaBorderRadius;

  final double imageBorderRadius;

  final String captionAlignment;

  final Alignment overlayTextAlignment;

  final bool showoverlayText;

  final bool autoResize;

  final String overlayText;

  final String caption;

  final double captionLeftPadding;

  final double captionRightPadding;

  final double captionTopPadding;

  final double captionBottomPadding;

  final double imageLeftPadding;

  final double imageRightPadding;

  final double imageTopPadding;

  final double imageBottomPadding;

  final double overlayTextFontSize;

  final Color captionColor;

  final Color overlayTextColor;

  final double captionFontSize;

  final double imageOpacity;

  final double horizontalElevation;

  final double verticalElevation;

  final Color shadowColor;

  final double shadowBlur;

  final double shadowSize;

  final String fontFamily;

  final double imageContainerHeight;

  final double imageContainerWidth;

  CustomImageContents(
      {this.showoverlayText,
        this.autoResize,
      this.semanticLabel,
      this.excludeFromSemantics = false,
      this.width,
      this.height,
      this.color = Colors.white,
      this.colorBlendMode,
      this.fit,
      this.alignment = Alignment.center,
      this.repeat = ImageRepeat.noRepeat,
      this.centerSlice,
      this.filterQuality = FilterQuality.low,
      this.key,
      this.outerAreaBorderRadius = 0,
      this.imageBorderRadius = 0,
      this.captionAlignment = 'top',
      this.overlayTextAlignment = Alignment.center,
      this.src,
      this.imageType = 'Network',
      this.overlayText = '',
      this.caption = '',
      this.captionFontSize = 10,
      this.overlayTextFontSize = 10,
      this.captionLeftPadding = 0,
      this.captionRightPadding = 0,
      this.captionTopPadding = 0,
      this.captionBottomPadding = 0,
      this.imageLeftPadding = 0,
      this.imageRightPadding = 0,
      this.imageTopPadding = 0,
      this.imageBottomPadding = 0,
      this.imageOpacity = 0.5,
      this.horizontalElevation = 5,
      this.verticalElevation = 5,
      this.shadowColor = Colors.black,
      this.shadowBlur = 2,
      this.shadowSize = 2,
      this.captionColor = Colors.black,
      this.overlayTextColor = Colors.black,
      this.fontFamily = 'Roboto',
      this.imageContainerHeight,
      this.imageContainerWidth});
}

///Widget Class
class MaterialCardData {
  ///parameter
  List<Widget> btnGrpList1;

  ///parameter
  List<Widget> btnGrpList2;

  ///parameter
  String imgPath;

  ///parameter
  String headerText;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  String bodyText;

  ///parameter
  String footerText;

  ///parameter
  String btnText;

  ///parameter
  String btnTextOne;

  ///parameter
  String btnTextTwo;

  ///parameter
  String btnViewone;

  ///parameter
  String btnViewtwo;

  ///parameter
  String btnViewthree;

  ///parameter
  Icon icon;

  ///parameter
  double imgHeight;

  ///parameter
  double imgWidth;

  ///parameter
  double containerHeight;

  ///parameter
  double containerWidth;

  ///parameter
  TextStyle textStyle1;

  ///parameter
  TextStyle textStyle2;

  ///parameter
  TextStyle textStyle3;

  ///parameter
  TextStyle textStyle4;

  ///parameter
  TextStyle textStyle5;

  ///parameter
  Decoration imgDecoration;

  ///parameter
  Decoration iconbgDecoration;

  ///parameter
  Decoration containerDecoration;

  ///parameter
  String imgType;

  ///parameter
  Color cardbgColor;

  ///parameter
  Color containerbgColor;

  ///parameter
  Color dividerColor;

  ///parameter
  Color ratingBarColor;

  ///parameter
  double initialRating;

  ///parameter
  void Function(double) onRatingUpdate;

  ///parameter
  bool iconVisibility;

  ///parameter
  bool visibilityCardHeaderTile;

  ///parameter
  bool visibilityCardImage;

  ///parameter
  bool visibilityCardFooter;

  ///parameter
  bool visibilityCardData;

  ///parameter
  bool visibilityCardActionBar;

  ///parameter
  FlipDirection flipDirection;

  ///parameter
  int flipSpeed;

  ///parameter
  Decoration decoration1;

  ///parameter
  Decoration decoration2;

  ///parameter
  double margin1;

  ///parameter
  double margin2;

  ///parameter
  double margin3;

  ///parameter
  double margin4;

  ///parameter
  double padding1;

  ///parameter
  double padding2;

  ///parameter
  double padding3;

  ///parameter
  double padding4;

  ///parameter
  Color btnColor;

  ///parameter
  ShapeBorder shapeButton;

  ///parameter
  double cardOpacity;

  ///parameter
  double elevation;

  ///parameter
  Color btnTextColor;

  ///parameter
  int imageFlex;

  ///parameter
  int text1Flex;

  ///parameter
  int text2Flex;

  ///parameter
  int text3Flex;

  ///parameter
  int text4Flex;

  ///parameter
  double borderRadius;

  ///parameter
  double borderWidth;

  ///parameter
  Color borderColor;

  ///parameter
  BoxShadow boxShadow;

  MaterialCardData(
      {@required this.btnGrpList1,
      @required this.btnGrpList2,
      @required this.imgPath,
      @required this.headerText,
      @required this.title,
      @required this.subtitle,
      @required this.bodyText,
      @required this.footerText,
      @required this.btnText,
      @required this.icon,
      @required this.imgHeight,
      @required this.imgWidth,
      @required this.containerHeight,
      @required this.containerWidth,
      @required this.textStyle1,
      @required this.textStyle2,
      @required this.textStyle3,
      @required this.textStyle4,
      @required this.textStyle5,
      @required this.btnViewone,
      @required this.imgDecoration,
      @required this.iconbgDecoration,
      @required this.containerDecoration,
      @required this.imgType,
      @required this.btnTextTwo,
      @required this.cardbgColor,
      @required this.containerbgColor,
      @required this.btnTextOne,
      @required this.btnViewtwo,
      @required this.btnViewthree,
      @required this.dividerColor,
      @required this.iconVisibility,
      @required this.visibilityCardHeaderTile,
      @required this.visibilityCardImage,
      @required this.visibilityCardFooter,
      @required this.visibilityCardData,
      @required this.visibilityCardActionBar,
      @required this.onRatingUpdate,
      @required this.flipSpeed,
      @required this.flipDirection,
      @required this.decoration1,
      @required this.decoration2,
      @required this.margin1,
      @required this.margin2,
      @required this.margin3,
      @required this.margin4,
      @required this.padding1,
      @required this.padding2,
      @required this.padding3,
      @required this.padding4,
      @required this.btnColor,
      @required this.shapeButton,
      @required this.elevation,
      @required this.cardOpacity,
      @required this.btnTextColor,
      @required this.initialRating,
      @required this.ratingBarColor,
      this.text4Flex,
      this.text3Flex,
      this.text2Flex,
      this.text1Flex,
      this.imageFlex,
      this.boxShadow,
      this.borderColor,
      this.borderWidth,
      this.borderRadius});
}

///Widget Class
class PaginatedDataTableData {
  ///parameter
  String headerText;

  ///parameter
  bool sortAscending;

  ///parameter
  int sortColumnIndex;

  ///parameter
  double columnSpacing;

  ///parameter
  double dataRowHeight;

  ///parameter
  double horizontalMargin;

  ///parameter
  List<int> availableRowsPerPage;

  ///parameter
  List<DataColumn> columns;

  ///parameter
  DataTableSource tableData;

  ///parameter
  ThemeData theme;

  ///parameter
  int rowsPerPage;

  ///parameter
  List<Widget> actions;
  PaginatedDataTableData(
      {@required this.availableRowsPerPage,
      @required this.columnSpacing,
      @required this.dataRowHeight,
      @required this.horizontalMargin,
      @required this.rowsPerPage,
      @required this.tableData,
      @required this.headerText,
      @required this.sortAscending,
      @required this.sortColumnIndex,
      @required this.actions,
      @required this.theme,
      @required this.columns});
}

///Widget Class
class SnackBarData {
  ///parameter
  String snackBarButtonText;

  ///parameter
  String snackBarContent;

  ///parameter
  String snackBarLabel;

  ///parameter
  Color bgColor;

  ///parameter
  Color labelColor;

  ///parameter
  Color textColor;

  ///parameter
  ShapeBorder shapeBorder;

  ///parameter
  int duration;

  SnackBarData(
      {@required this.snackBarButtonText,
      @required this.snackBarContent,
      @required this.snackBarLabel,
      @required this.bgColor,
      @required this.labelColor,
      @required this.textColor,
      @required this.shapeBorder,
      @required this.duration});
}

///Widget Class
class ExpandablePanelData {
  ///parameter
  final String title;

  ///parameter
  final Icon icon;

  ///parameter
  final List<Widget> widget;

  ///parameter
  final ThemeData themeData;

  ///parameter
  ExpandablePanelData(this.title, this.icon, this.widget, this.themeData);
}

///Widget Class
class MaterialChipData {
  ///parameter
  String labelText;

  ///parameter
  String tooltipMsg;

  ///parameter
  String deleteMsg;

  ///parameter
  Color checkmarkColor;

  ///parameter
  Color bgColor;

  ///parameter
  Color labelColor;

  ///parameter
  Color selectedbgColor;

  ///parameter
  ShapeBorder shapeBorder;

  MaterialChipData(
      {@required this.labelText,
      @required this.tooltipMsg,
      @required this.deleteMsg,
      @required this.checkmarkColor,
      @required this.bgColor,
      @required this.labelColor,
      @required this.shapeBorder,
      @required this.selectedbgColor});
}

///Widget Class
class SimpleDialogData {
  ///parameter
  String dialogHeader;

  ///parameter
  String dialogContent;

  ///parameter
  String dialogButtonText;

  ///parameter
  double height;

  ///parameter
  double width;

  ///parameter
  ShapeBorder shapeBorder;

  ///parameter
  Color bgColor;

  ///parameter
  Color headerTextColor;

  ///parameter
  Color bodyTextColor;

  ///parameter
  Color btnTextColor;

  ///parameter
  Color btnColor;

  SimpleDialogData(
      {@required this.dialogHeader,
      @required this.dialogContent,
      @required this.dialogButtonText,
      @required this.height,
      @required this.width,
      @required this.shapeBorder,
      @required this.bgColor,
      @required this.headerTextColor,
      @required this.bodyTextColor,
      @required this.btnTextColor,
      @required this.btnColor});
}

///Widget Class
class CustomTileData {
  ///parameter
  Widget leading;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  String trailingTopText;

  ///parameter
  String trailingBottomText;

  ///parameter
  bool enabled;

  ///parameter
  bool selected;

  ///parameter
  bool stubMode;

  CustomTileData(
      {this.leading,
      this.title,
      this.subtitle,
      this.trailingTopText,
      this.trailingBottomText,
      this.enabled = true,
      this.selected = false,
      this.stubMode = true});
}

///Widget Class
class CustomListTileParameters {
  ///parameter
  bool isThreeLine;

  ///parameter
  bool dense;

  ///parameter
  EdgeInsetsGeometry contentPadding;

  ///parameter
  GestureTapCallback onTap;

  ///parameter
  GestureLongPressCallback onLongPress;

  ///parameter
  FontWeight fontWeight;

  ///parameter
  double fontSize;

  ///parameter
  String fontFamily;

  ///parameter
  Color textColor;

  ///parameter
  Color listBgColor;

  ///parameter
  Color iconBgColor;

  ///parameter
  double circularRadius;

  ///parameter
  double listHeight;

  ///parameter
  double listWidth;

  ///parameter
  double iconHeight;

  ///parameter
  double iconWidth;

  CustomListTileParameters(
      {this.isThreeLine = false,
      this.dense,
      this.contentPadding,
      this.onTap,
      this.onLongPress,
      this.textColor,
      this.fontFamily,
      this.fontWeight,
      this.fontSize,
      this.circularRadius,
      this.iconBgColor,
      this.listBgColor,
      this.listHeight,
      this.iconHeight,
      this.iconWidth,
      this.listWidth});
}

///Widget Class
class DropDownParameters {
  ///parameter
  String hintText;

  ///parameter
  List<String> itemsList;

  ///parameter
  String listType;

  ///parameter
  Color textColor;

  ///parameter
  Color hintTextColor;

  ///parameter
  FontWeight hintFontWeight;

  ///parameter
  FontStyle hintFontStyle;

  ///parameter
  double hintFontSize;

  ///parameter
  String hintfontFamily;

  ///parameter
  Color fillColor;

  ///parameter
  Color itemsBgColor;

  ///parameter
  Color iconEnabledColor;

  ///parameter
  TextAlign textAlign;

  ///parameter
  double width;

  ///parameter
  double height;

  ///parameter
  double imageWidth;

  ///parameter
  double imageHeight;

  ///parameter
  String fontFamily;

  ///parameter
  FontWeight fontWeight;

  ///parameter
  FontStyle fontStyle;

  ///parameter
  double fontSize;

  ///parameter
  double shadowBlurRadius;

  ///parameter
  double shadowSpreadRadius;

  ///parameter
  double shadowOffsetX;

  ///parameter
  double shadowOffsetY;

  ///parameter
  double borderRadius;

  ///parameter
  Color shadowColor;

  ///parameter
  Key key;

  DropDownParameters(
      {@required this.itemsList,
      this.hintText,
      this.textColor,
      this.height,
      this.width,
      this.fontFamily,
      this.fontStyle,
      this.fontWeight,
      this.fontSize,
      this.fillColor,
      this.imageWidth,
      this.imageHeight,
      this.textAlign,
      this.shadowBlurRadius,
      this.shadowSpreadRadius,
      this.shadowOffsetX,
      this.shadowOffsetY,
      this.listType,
      this.borderRadius,
      this.itemsBgColor,
      this.iconEnabledColor,
      this.shadowColor,
      this.hintFontSize,
      this.hintFontStyle,
      this.hintFontWeight,
      this.hintTextColor,
      this.hintfontFamily,
      this.key});
}

///Widget Class
class StepperParameters {
  ///parameter
  ScrollPhysics physics;

  ///parameter
  StepperType type;

  ///parameter
  int currentStep;

  ///parameter
  ValueChanged<int> onStepTapped;

  ///parameter
  VoidCallback onStepContinue;

  ///parameter
  VoidCallback onStepCancel;

  ///parameter
  ControlsWidgetBuilder controlsBuilder;

  StepperParameters(
      {Key key,
      this.physics,
      this.type = StepperType.vertical,
      this.currentStep,
      this.onStepTapped,
      this.onStepContinue,
      this.onStepCancel,
      this.controlsBuilder});
}

///Widget Class
class CustomSteps {
  ///parameter
  Widget title;

  ///parameter
  Widget subtitle;

  ///parameter
  Widget content;

  ///parameter
  StepState state;

  ///parameter
  bool isActive;

  CustomSteps(
      {this.title, this.subtitle, this.content, this.state, this.isActive});
}

///Widget Class
class CustomVerticalTabParameters {
  ///parameter
  final Key key;

  ///parameter
  final double tabsWidth;

  ///parameter
  final double itemExtent;

  ///parameter
  final double indicatorWidth;

  ///parameter
  final TextDirection direction;

  ///parameter
  final Color indicatorColor;

  ///parameter
  final bool disabledChangePageFromContentView;

  ///parameter
  final Axis contentScrollAxis;

  ///parameter
  final Color selectedTabBackgroundColor;

  ///parameter
  final Color unselectedTabBackgroundColor;

  ///parameter
  final Color dividerColor;

  ///parameter
  final Duration changePageDuration;

  ///parameter
  final Curve changePageCurve;

  ///parameter
  final Color tabsShadowColor;

  ///parameter
  final double tabsElevation;

  ///parameter
  final Color iconColor;

  ///parameter
  final Color tabsTextColor;

  CustomVerticalTabParameters(
      {this.key,
      this.tabsWidth,
      this.itemExtent,
      this.indicatorWidth,
      this.direction,
      this.indicatorColor,
      this.disabledChangePageFromContentView,
      this.contentScrollAxis,
      this.selectedTabBackgroundColor,
      this.unselectedTabBackgroundColor,
      this.dividerColor,
      this.changePageCurve,
      this.changePageDuration,
      this.tabsShadowColor,
      this.tabsElevation,
      this.iconColor,
      this.tabsTextColor});
}

///Widget Class
class CustomFingerprintParameters {
  ///parameter
  final Widget tapWidget;

  ///parameter
  final String authText;

  ///parameter
  final Color backgroundColor;

  ///parameter
  final Color textColor;

  ///parameter
  final double textSize;

  CustomFingerprintParameters(
      {this.tapWidget,
      this.authText,
      this.backgroundColor,
      this.textColor,
      this.textSize});
}

///Icon
class IconState {
  ///parameter
  IconData icon;

  ///parameter
  Color color;

  ///parameter
  double size;

  IconState({this.icon, this.color, this.size});
}

///Sub-Widget model Definition
class Area {
  ///parameter
  String header;

  ///parameter
  Widget widget;

  ///parameter
  String label;

  Area(this.header, this.widget, this.label);
}

///Grid model Definition
class Grid {
  ///parameter
  int count;

  ///parameter
  double crossaxisspacing;

  ///parameter
  double mainaxisspacing;

  ///parameter
  Color cardColour;

  ///parameter
  Color textColour;

  ///parameter
  final void Function(int, String) callback;

  ///parameter
  final void Function(int, String, String) longcallback;
  Grid(
      {this.count,
      this.callback,
      this.longcallback,
      this.crossaxisspacing,
      this.mainaxisspacing,
      this.cardColour,
      this.textColour});
}

///Widget Class
class CustomGrid {
  ///parameter
  int count;

  ///parameter
  double cas;

  ///parameter
  double mas;

  ///parameter
  String cardtype;

  ///parameter
  final void Function(int, String) callback;

  ///parameter
  final void Function(int, String, String) longcallback;
  CustomGrid(this.count, this.callback, this.longcallback, this.cas, this.mas,
      this.cardtype);
}

///Model for the DataTable
class DataTableSchema {
  ///parameter
  RowColumn columns;

  ///parameter
  int sortColumnIndex;

  ///parameter
  bool sortAscending;

  ///parameter
  List<RowColumn> rows;

  ///parameter
  Color backgroundColour;

  ///parameter
  Color rowtextColour;

  ///parameter
  double rowtextSize;

  ///parameter
  Color columntextColour;

  ///parameter
  double columntextSize;

  DataTableSchema(
      {this.columns,
      this.sortColumnIndex,
      this.sortAscending,
      this.rows,
      this.backgroundColour,
      this.rowtextColour,
      this.columntextColour,
      this.columntextSize,
      this.rowtextSize});
}

///Model for rows
class RowColumn {
  ///parameter
  List<String> rowcolumn;

  ///parameter
  RowColumn(this.rowcolumn);
}

///Widget Class
class CustomPainterParameters {
  ///parameter
  Color color;

  ///parameter
  StrokeCap strokeCap;

  ///parameter
  final double strokeWidth;

  CustomPainterParameters({
    this.color,
    this.strokeCap,
    this.strokeWidth,
  });
}

///Widget Class
class CustomCanvasOptionsParameters {
  ///parameter
  double heightColor;

  ///parameter
  double heightThickness;

  ///parameter
  double widthColor;

  ///parameter
  double widthThickness;

  ///parameter
  double fontSizeColour;

  ///parameter
  double fontSizeThickness;

  ///parameter
  Color textColorColour;

  ///parameter
  Color textColorThickness;

  ///parameter
  Color bgColorColour;

  ///parameter
  Color bgColorThickness;

  ///parameter
  String fontFamilyColour;

  ///parameter
  String fontFamilyThickness;

  ///parameter
  FontWeight fontWeightColour;

  ///parameter
  FontWeight fontWeightThickness;

  ///parameter
  Color borderColor;

  ///parameter
  double borderWidth;

  ///parameter
  Color btnColor;

  CustomCanvasOptionsParameters(
      {this.bgColorColour,
      this.bgColorThickness,
      this.fontFamilyColour,
      this.fontFamilyThickness,
      this.fontSizeColour,
      this.fontSizeThickness,
      this.fontWeightColour,
      this.fontWeightThickness,
      this.heightColor,
      this.heightThickness,
      this.textColorColour,
      this.textColorThickness,
      this.widthColor,
      this.widthThickness,
      this.borderWidth,
      this.borderColor,
      this.btnColor});
}

///Widget Class
class OpportunityDetailsCardData {
  ///parameter
  double height;

  ///parameter
  double width;

  ///parameter
  String amount;

  ///parameter
  String status;

  ///parameter
  String heading;

  ///parameter
  String headingValue;

  ///parameter
  String subheadingOne;

  ///parameter
  String subheadingValueOne;

  ///parameter
  String subheadingTwo;

  ///parameter
  String subheadingValueTwo;

  ///parameter
  Widget subheadingIconOne;

  ///parameter
  Widget subheadingIconTwo;

  ///parameter
  Color backgroundColor;

  ///parameter
  Color statusBackgroundColor;

  ///parameter
  double cardRadius;

  ///parameter
  double statusRadius;

  ///parameter
  String headingTextFamily;

  ///parameter
  String headingValueTextFamily;

  ///parameter
  String subheadingOneTextFamily;

  ///parameter
  String subheadingTwoTextFamily;

  ///parameter
  String subheadingValueOneTextFamily;

  ///parameter
  String subheadingValueTwoTextFamily;

  ///parameter
  String statusTextFamily;

  ///parameter
  double headingTextSize;

  ///parameter
  double headingValueTextSize;

  ///parameter
  double subheadingOneTextSize;

  ///parameter
  double subheadingTwoTextSize;

  ///parameter
  double subheadingValueOneTextSize;

  ///parameter
  double subheadingValueTwoTextSize;

  ///parameter
  double statusTextSize;

  ///parameter
  FontWeight headingTextWeight;

  ///parameter
  FontWeight headingValueTextWeight;

  ///parameter
  FontWeight subheadingOneTextWeight;

  ///parameter
  FontWeight subheadingTwoTextWeight;

  ///parameter
  FontWeight subheadingValueOneTextWeight;

  ///parameter
  FontWeight subheadingValueTwoTextWeight;

  ///parameter
  FontWeight statusTextWeight;

  ///parameter
  Color headingTextColor;

  ///parameter
  Color headingValueTextColor;

  ///parameter
  Color subheadingOneTextColor;

  ///parameter
  Color subheadingTwoTextColor;

  ///parameter
  Color subheadingValueOneTextColor;

  ///parameter
  Color subheadingValueTwoTextColor;

  ///parameter
  Color statusTextColor;

  ///parameter
  bool shadow;

  ///parameter
  Color shadowColor;

  ///parameter
  double shadowOffset;

  ///parameter
  Color border;

  ///parameter
  String amountTextFamily;

  ///parameter
  double amountTextSize;

  ///parameter
  FontWeight amountTextWeight;

  ///parameter
  Color amountTextColor;

  ///parameter
  double cardWidth;

  ///parameter
  double padding;

  OpportunityDetailsCardData(
      {this.height = 300,
      this.width = double.infinity,
      this.amount = 'INR 1.2 Crore',
      this.status = 'Won',
      this.heading = 'Account Name',
      this.headingValue = 'Company Name',
      this.subheadingOne = 'Close Date',
      this.subheadingValueOne = '18/05/2020',
      this.subheadingTwo = 'Record Status',
      this.subheadingValueTwo = 'Lock',
      this.subheadingIconOne,
      this.subheadingIconTwo,
      this.backgroundColor = Colors.white,
      this.statusBackgroundColor = Colors.black,
      this.cardRadius = 6,
      this.statusRadius = 30,
      this.headingTextFamily = 'Roboto',
      this.headingValueTextFamily = 'Roboto',
      this.subheadingOneTextFamily = 'Roboto',
      this.subheadingTwoTextFamily = 'Roboto',
      this.subheadingValueOneTextFamily = 'Roboto',
      this.subheadingValueTwoTextFamily = 'Roboto',
      this.statusTextFamily = 'Roboto',
      this.headingTextSize = 14,
      this.headingValueTextSize = 16,
      this.subheadingOneTextSize = 14,
      this.subheadingTwoTextSize = 14,
      this.subheadingValueOneTextSize = 14,
      this.subheadingValueTwoTextSize = 14,
      this.statusTextSize = 10,
      this.headingTextWeight = FontWeight.bold,
      this.headingValueTextWeight = FontWeight.normal,
      this.subheadingOneTextWeight = FontWeight.bold,
      this.subheadingTwoTextWeight = FontWeight.bold,
      this.subheadingValueOneTextWeight = FontWeight.normal,
      this.subheadingValueTwoTextWeight = FontWeight.normal,
      this.statusTextWeight = FontWeight.normal,
      this.headingTextColor = Colors.black,
      this.headingValueTextColor = Colors.black,
      this.subheadingOneTextColor = Colors.black,
      this.subheadingTwoTextColor = Colors.black,
      this.subheadingValueOneTextColor = Colors.black,
      this.subheadingValueTwoTextColor = Colors.black,
      this.statusTextColor = Colors.white,
      this.shadow = false,
      this.shadowColor = Colors.black,
      this.shadowOffset = 10,
      this.border = Colors.black,
      this.amountTextFamily = 'Roboto',
      this.amountTextSize = 14,
      this.amountTextWeight = FontWeight.bold,
      this.amountTextColor = Colors.orange,
      this.cardWidth = 300,
      this.padding = 20});
}

///Widget Class
class CardWithLeftThumbnailData {
  ///parameter
  Color cardBackgroundColor;

  ///parameter
  double borderRadius;

  ///parameter
  bool shadow;

  ///parameter
  Color shadowColor;

  ///parameter
  double shadowRadius;

  ///parameter
  String heading;

  ///parameter
  Color headingTextColor;

  ///parameter
  double headingTextSize;

  ///parameter
  FontWeight headingTextWeight;

  ///parameter
  String headingTextFamily;

  ///parameter
  double paddingValue;

  ///parameter
  Widget icon;

  ///parameter
  Color iconColor;

  ///parameter
  double iconHeight;

  ///parameter
  double iconWidth;

  ///parameter
  double thumbnailHeight;

  ///parameter
  double thumbnailWidth;

  ///parameter
  Color iconBackgroundColor;

  ///parameter
  Widget leftBottomWidget;

  ///parameter
  Widget rightMiddleWidget;

  ///parameter
  Widget rightBottomWidget;

  CardWithLeftThumbnailData(
      {this.cardBackgroundColor = Colors.black,
      this.borderRadius = 6,
      this.shadow = false,
      this.shadowColor = Colors.black,
      this.shadowRadius = 10,
      this.heading = 'Card Heading',
      this.headingTextColor = Colors.white,
      this.headingTextSize = 14,
      this.headingTextWeight = FontWeight.bold,
      this.headingTextFamily = 'Roboto',
      this.paddingValue = 20,
      this.icon,
      this.iconColor = Colors.black,
      this.iconHeight = 20,
      this.iconWidth = 20,
      this.thumbnailWidth = 50,
      this.thumbnailHeight = 50,
      this.iconBackgroundColor = Colors.white,
      this.leftBottomWidget,
      this.rightMiddleWidget,
      this.rightBottomWidget});
}

///Widget Class
class StatusCardData {
  ///parameter
  double cardHeight;

  ///parameter
  double cardWidth;

  ///parameter
  Color backgroundColor;

  ///parameter
  String heading;

  ///parameter
  String headingTextFamily;

  ///parameter
  double headingTextSize;

  ///parameter
  FontWeight headingTextWeight;

  ///parameter
  Color headingTextColor;

  ///parameter
  String subheading;

  ///parameter
  String subheadingTextFamily;

  ///parameter
  double subheadingTextSize;

  ///parameter
  FontWeight subheadingTextWeight;

  ///parameter
  Color subheadingTextColor;

  ///parameter
  String status;

  ///parameter
  String statusTextFamily;

  ///parameter
  double statusTextSize;

  ///parameter
  FontWeight statusTextWeight;

  ///parameter
  Color statusTextColor;

  ///parameter
  Color statusBackground;

  ///parameter
  double cardRadius;

  ///parameter
  double statusRadius;

  StatusCardData(
      {this.cardHeight = 300,
      this.cardWidth = 200,
      this.backgroundColor = Colors.white,
      this.heading = 'Card Heading',
      this.headingTextFamily = 'Roboto',
      this.headingTextSize = 20,
      this.headingTextWeight = FontWeight.normal,
      this.headingTextColor = Colors.white,
      this.subheading = 'Card Subheading',
      this.subheadingTextFamily = 'Roboto',
      this.subheadingTextSize = 14,
      this.subheadingTextWeight = FontWeight.bold,
      this.subheadingTextColor = Colors.white,
      this.status = 'Status',
      this.statusTextFamily = 'Roboto',
      this.statusTextSize = 10,
      this.statusTextWeight = FontWeight.normal,
      this.statusTextColor = Colors.black,
      this.statusBackground = Colors.white,
      this.cardRadius = 6,
      this.statusRadius = 30});
}

///Widget Class
class PlaceLocation {
  ///parameter
  final double latitude;

  ///parameter
  final double longitude;

  ///parameter
  final String address;

  const PlaceLocation({
    @required this.latitude,
    @required this.longitude,
    this.address,
  });
}

///Widget Class
class ServicesData {
  ///parameter
  final String serviceType;

  ///parameter
  final int serviceNumber;

  ///parameter
  final Color mColor;

  ServicesData(this.serviceType, this.serviceNumber, this.mColor);
}

///Widget Class
class LinearSales {
  ///parameter
  final int year;

  ///parameter
  final int sales;

  LinearSales(this.year, this.sales);
}

///Widget Class
class FlatButtonParameters {
  @required
  Widget child;

  ///parameter
  Color color;

  ///parameter
  Brightness colorBrightness;

  ///parameter
  Color disabledColor;

  ///parameter
  double disabledElevation;

  ///parameter
  Color disabledTextColor;

  ///parameter
  Color focusColor;

  ///parameter
  FocusNode focusNode;

  ///parameter
  double height;

  ///parameter
  Color highlightColor;

  ///parameter
  Color splashColor;

  ///parameter
  Color hoverColor;

  ///parameter
  Color textColor;

  ///parameter
  bool autofocus;

  ///parameter
  double width;

  ///parameter
  ShapeBorder shape;

  ///parameter
  ButtonTextTheme textTheme;
  String text;

  TextAlign textAlign;
  int maxLines;
  double fontSize;
  FontWeight fontWeight;
  FontStyle fontStyle;
  String fontFamily;
  Alignment cAlign;
  Color ContainerColor;
  Color BorderColor;
  double border_radius;
  double offsetdx;
  double offsetdy;
  double spread_radius;
  double blur_radius;
  Color boxshadowcolor;
  double icon1_size;
  double icon2_size;
  Color icon1_color;
  Color icon2_color;
  IconData icon1;
  IconData icon2;
  double pad_val_all_wrap_text;
  double pad_val_top_wrap_text;
  double pad_val_bottom_wrap_text;
  double pad_val_l_wrap_text;
  double pad_val_r_wrap_text;
  double pad_val_all_wrap_icon;
  double pad_val_top_wrap_icon;
  double pad_val_bottom_wrap_icon;
  double pad_val_l_wrap_icon;
  double pad_val_r_wrap_icon;
  double opacity;
  Function onpress;
  //Color splashcolor;
  ///parameter
  Key key;

  FlatButtonParameters(
      {this.child,
      this.color,
      this.cAlign,
      this.colorBrightness,
      this.disabledColor,
      this.disabledElevation,
      this.disabledTextColor,
      this.focusColor,
      this.focusNode,
      this.height,
      this.highlightColor,
      this.splashColor,
      this.textTheme,
      this.hoverColor,
      this.textColor,
      this.autofocus,
      this.shape,
      this.width,
      this.key,
      this.text,
      this.opacity,
      this.icon1_size,
      this.pad_val_bottom_wrap_icon,
      this.pad_val_l_wrap_icon,
      this.pad_val_r_wrap_icon,
      this.pad_val_top_wrap_icon,
      this.pad_val_bottom_wrap_text,
      this.pad_val_r_wrap_text,
      this.pad_val_top_wrap_text,
      this.pad_val_l_wrap_text,
      this.pad_val_all_wrap_text,
      this.pad_val_all_wrap_icon,
      this.icon2,
      this.spread_radius,
      this.icon1,
      this.icon1_color,
      this.blur_radius,
      this.offsetdx,
      this.boxshadowcolor,
      this.border_radius,
      this.BorderColor,
      this.ContainerColor,
      this.offsetdy,
      this.icon2_color,
      this.icon2_size,
      this.fontFamily,
      this.fontSize,
      this.fontStyle,
      this.fontWeight,
      this.maxLines,
      this.textAlign,
      //this.splashcolor,
      this.onpress});
}

class CardParameters {
  Color defaultBackgroundColor = Colors.white;
  double defaultImageHeight;
  double defaultImageWidth;
  double defaultTextCardWidth;
  double defaultTextCardHeight;
  bool imageAvailable;
  bool textAvailable;
  double defaultFontSize;
  double defaultFontFamily;
  Color defaultFontColor;
  String imagePath;
  Map keyValueMap;
  double elevation;
  Color shadowColor;
  double borderRadius;
  double cardWidth;
  double textPadding;
  Color backgroundColor;
  dynamic apiData;

  CardParameters(
      {this.defaultBackgroundColor,
      this.defaultFontColor,
      this.defaultFontFamily,
      this.defaultFontSize,
      this.defaultImageHeight,
      this.defaultImageWidth,
      this.defaultTextCardHeight,
      this.defaultTextCardWidth,
      this.imagePath,
      this.keyValueMap,
      this.elevation,
      this.borderRadius,
      this.imageAvailable,
      this.textAvailable,
      this.shadowColor,
      this.cardWidth,
      this.textPadding,
      this.backgroundColor,
      this.apiData});
}

class CustomCard {
  final Color tagCloudTextColor;
  final double elevation;
  final double radius;
  final Color shadowcolor;
  final Widget child;
  final String title;
  final String subtitle;
  final String imageurl;
  final double titleFontSize;
  final double subtitleFontSize;
  //icon1
  final IconData icon1_value;
  final double icon1_size;
  final Color icon1_color;
  //icon2
  final IconData icon2_value;
  final double icon2_size;
  final Color icon2_color;
  //tapcloud1

  final double tap_c1radius;
  final Color tap_c1colors;
  final double tap_c1pad_val_all_wrap;
  final double tap_c1pad_val_top_wrap;
  final double tap_c1pad_val_bottom_wrap;
  final double tap_c1pad_val_l_wrap;
  final double tap_c1pad_val_r_wrap;
  final double tap_c1pad_val_all;
  final double tap_c1pad_val_top;
  final double tap_c1pad_val_bottom;
  final double tap_c1pad_val_l;
  final double tap_c1pad_val_r;
  final Alignment tap_c1alignment;
  final Widget tap_c1child;
  //tapclod2

  final double tap_c2radius;
  final Color tap_c2colors;
  final double tap_c2pad_val_all_wrap;
  final double tap_c2pad_val_top_wrap;
  final double tap_c2pad_val_bottom_wrap;
  final double tap_c2pad_val_l_wrap;
  final double tap_c2pad_val_r_wrap;
  final double tap_c2pad_val_all;
  final double tap_c2pad_val_top;
  final double tap_c2pad_val_bottom;
  final double tap_c2pad_val_l;
  final double tap_c2pad_val_r;
  final Alignment tap_c2alignment;
  final Widget tap_c2child;

  //textButton
  final Function Textonpressed;
  final Widget Textchild;
  final double Textpad_val_all_wrap;
  final double Textpad_val_top_wrap;
  final double Textpad_val_bottom_wrap;
  final double Textpad_val_l_wrap;
  final double Textpad_val_r_wrap;

  //divider
  final double div_height;
  final double div_thickness;
  final double div_indent;
  final double div_endIndent;
  final Color div_color;
  final double div_pad_val_all_wrap;
  final double div_pad_val_top_wrap;
  final double div_pad_val_bottom_wrap;
  final double div_pad_val_l_wrap;
  final double div_pad_val_r_wrap;

  //oulineButton1
  final Color oulineButton1color;
  final double oulineButton1radius;
  final Function oulineButton1function;
  final Widget oulineButton1child;
  final double oulineButton1pad_val_all_wrap;
  final double oulineButton1pad_val_top_wrap;
  final double oulineButton1pad_val_bottom_wrap;
  final double oulineButton1pad_val_l_wrap;
  final double oulineButton1pad_val_r_wrap;

  //oulineButton2
  final Color oulineButton2color;
  final double oulineButton2radius;
  final Function oulineButton2function;
  final Widget oulineButton2child;
  final double oulineButton2pad_val_all_wrap;
  final double oulineButton2pad_val_top_wrap;
  final double oulineButton2pad_val_bottom_wrap;
  final double oulineButton2pad_val_l_wrap;
  final double oulineButton2pad_val_r_wrap;

  //listTile
  final Widget listTiletitle;
  final Widget listTilesubtitle;
  final Widget listTiletrailing;
  final double listTilepad_val_all_wrap;
  final double listTilepad_val_top_wrap;
  final double listTilepad_val_bottom_wrap;
  final double listTilepad_val_l_wrap;
  final double listTilepad_val_r_wrap;

  //imagecontainer
  final double imagecontainerheight;
  final double imagecontainerwidth;
  final Widget imagecontainerchild;
  final double imagecontainerpad_val_all_wrap;
  final double imagecontainerpad_val_top_wrap;
  final double imagecontainerpad_val_bottom_wrap;
  final double imagecontainerpad_val_l_wrap;
  final double imagecontainerpad_val_r_wrap;

  //cardcontainer

  final double cardcontainerheight;
  final double cardcontainerwidth;
  final Widget cardcontainerchild;
  final double cardcontainerpad_val_all_wrap;
  final double cardcontainerpad_val_top_wrap;
  final double cardcontainerpad_val_bottom_wrap;
  final double cardcontainerpad_val_l_wrap;
  final double cardcontainerpad_val_r_wrap;

  //tagcloudpram
  final String tagCloudString;
  final Color tagCloudColor;

  CustomCard(
      {this.titleFontSize,
      this.subtitleFontSize,
      this.elevation,
      this.radius,
      this.child,
      this.shadowcolor,
      this.title,
      this.subtitle,
      this.imageurl,
      this.icon1_value,
      this.icon1_color,
      this.icon1_size,
      this.icon2_color,
      this.icon2_size,
      this.icon2_value,
      this.tap_c1radius,
      this.tap_c1colors,
      this.tap_c1pad_val_all_wrap,
      this.tap_c1pad_val_top_wrap,
      this.tap_c1pad_val_bottom_wrap,
      this.tap_c1pad_val_l_wrap,
      this.tap_c1pad_val_r_wrap,
      this.tap_c1pad_val_all,
      this.tap_c1pad_val_top,
      this.tap_c1pad_val_bottom,
      this.tap_c1pad_val_l,
      this.tap_c1pad_val_r,
      this.tap_c1alignment,
      this.tap_c1child,
      this.tap_c2radius,
      this.tap_c2colors,
      this.tap_c2pad_val_all_wrap,
      this.tap_c2pad_val_top_wrap,
      this.tap_c2pad_val_bottom_wrap,
      this.tap_c2pad_val_l_wrap,
      this.tap_c2pad_val_r_wrap,
      this.tap_c2pad_val_all,
      this.tap_c2pad_val_top,
      this.tap_c2pad_val_bottom,
      this.tap_c2pad_val_l,
      this.tap_c2pad_val_r,
      this.tap_c2alignment,
      this.tap_c2child,
      this.Textonpressed,
      this.Textchild,
      this.Textpad_val_all_wrap,
      this.Textpad_val_top_wrap,
      this.Textpad_val_bottom_wrap,
      this.Textpad_val_l_wrap,
      this.Textpad_val_r_wrap,
      this.div_height,
      this.div_color,
      this.div_thickness,
      this.div_endIndent,
      this.div_indent,
      this.div_pad_val_all_wrap,
      this.div_pad_val_top_wrap,
      this.div_pad_val_bottom_wrap,
      this.div_pad_val_l_wrap,
      this.div_pad_val_r_wrap,
      this.oulineButton1color,
      this.oulineButton1function,
      this.oulineButton1child,
      this.oulineButton1radius,
      this.oulineButton1pad_val_all_wrap,
      this.oulineButton1pad_val_top_wrap,
      this.oulineButton1pad_val_bottom_wrap,
      this.oulineButton1pad_val_l_wrap,
      this.oulineButton1pad_val_r_wrap,
      this.oulineButton2color,
      this.oulineButton2function,
      this.oulineButton2child,
      this.oulineButton2radius,
      this.oulineButton2pad_val_all_wrap,
      this.oulineButton2pad_val_top_wrap,
      this.oulineButton2pad_val_bottom_wrap,
      this.oulineButton2pad_val_l_wrap,
      this.oulineButton2pad_val_r_wrap,
      this.listTilepad_val_all_wrap,
      this.listTilepad_val_top_wrap,
      this.listTilepad_val_bottom_wrap,
      this.listTilepad_val_l_wrap,
      this.listTilepad_val_r_wrap,
      this.listTiletitle,
      this.listTilesubtitle,
      this.listTiletrailing,
      this.imagecontainerheight,
      this.imagecontainerchild,
      this.imagecontainerwidth,
      this.imagecontainerpad_val_all_wrap,
      this.imagecontainerpad_val_top_wrap,
      this.imagecontainerpad_val_bottom_wrap,
      this.imagecontainerpad_val_l_wrap,
      this.imagecontainerpad_val_r_wrap,
      this.cardcontainerpad_val_all_wrap,
      this.cardcontainerpad_val_top_wrap,
      this.cardcontainerpad_val_bottom_wrap,
      this.cardcontainerpad_val_l_wrap,
      this.cardcontainerpad_val_r_wrap,
      this.cardcontainerwidth,
      this.cardcontainerchild,
      this.cardcontainerheight,
      this.tagCloudColor,
      this.tagCloudString,
      this.tagCloudTextColor});
}

//DrawerPrameters
class DrawerParameters {
  final String urlImage;
  final String name;
  final String email;
  final String phone;
  final List<Map<String, IconData>> items;
  final Color drawerColor;
  final Color iconTextColor;
  final Color hoverColor;

  DrawerParameters({
    this.name = '',
    this.urlImage = '',
    this.iconTextColor = Colors.black,
    this.drawerColor = Colors.white,
    this.items,
    this.phone = '',
    this.email = '',
    this.hoverColor = Colors.grey,
  });
}

class AppBarParams {
  final double elevation;
  final Color backgroundColor;
  final Color shadowColor;
  final double bottomRadius;
  final String text;
  final String pramPreviousPage;
  final IconData icon1;
  final IconData icon2;
  final IconData icon3;
  final IconData icon4;
  final String imageUrl;
  final Function function;
  final Color textColor;
  final Color iconColor;
  final double leftPadImage;
  final double topPadImage;
  final double bottomPadImage;
  final double rightPadImage;
  final double imageWidth;
  final String drawerPosition;
  AppBarParams(
      {this.function,
      this.text = '',
      this.pramPreviousPage = '',
      this.backgroundColor = Colors.black,
      this.shadowColor = Colors.transparent,
      this.elevation = 4.0,
      this.icon1 = null,
      this.icon2 = null,
      this.icon3 = null,
      this.icon4 = null,
      this.bottomPadImage = 0.0,
      this.bottomRadius = 0.0,
      this.imageUrl = '',
      this.leftPadImage = 0.0,
      this.textColor = Colors.black,
      this.iconColor = Colors.black,
      this.topPadImage = 0.0,
      this.rightPadImage = 0.0,
      this.drawerPosition = 'Right',
      this.imageWidth = 0.0});
}

class Switchparms {
  final Color activeColor;
  final Color activeTrackColor;
  final Color inactiveThumbColor;
  final Color inactiveTrackColor;
  final Function toggleSwitch;
  final bool value;
  final double scale;

  Switchparms({
    this.activeColor = Colors.white,
    this.activeTrackColor = Colors.white,
    this.inactiveThumbColor = Colors.white,
    this.inactiveTrackColor = Colors.white,
    this.toggleSwitch,
    this.value = false,
    this.scale = 1.0,
  });
}

class Chartparms {
  final String ChartType;
  final barColor;
  final String apiUrl;
  final String apiPath;
  final int barChartRadius;
  final List<String> comparisonVal;
  final int arcValue;
  final int labelFontSize;
  final int desiredMaxRows;
  final bool sameColor;
  final List<charts.Series<dynamic, dynamic>> series;
  Chartparms(
      {this.ChartType,
      this.labelFontSize,
      this.arcValue,
      this.apiUrl,
      this.desiredMaxRows,
      this.series,
      this.apiPath,
      this.comparisonVal,
      this.barColor,
      this.sameColor,
      this.barChartRadius});
}

class TextParameters {
  String text;
  Alignment cAlign;
  TextAlign textAlign;
  int maxLines;
  double fontSize;
  double height;
  Color textColor;
  FontWeight fontWeight;
  FontStyle fontStyle;
  String fontFamily;
  Color ContainerColor;
  Color BorderColor;
  double border_radius;
  double offsetdx;
  double offsetdy;
  double spread_radius;
  double blur_radius;
  Color boxshadowcolor;
  double icon1_size;
  double icon2_size;
  Color icon1_color;
  Color icon2_color;
  IconData icon1;
  IconData icon2;
  double pad_val_all_wrap_text;
  double pad_val_top_wrap_text;
  double pad_val_bottom_wrap_text;
  double pad_val_l_wrap_text;
  double pad_val_r_wrap_text;
  double pad_val_all_wrap_icon;
  double pad_val_top_wrap_icon;
  double pad_val_bottom_wrap_icon;
  double pad_val_l_wrap_icon;
  double pad_val_r_wrap_icon;
  double opacity;

  TextParameters({
    this.text,
    this.fontSize,
    this.height,
    this.cAlign,
    this.maxLines,
    this.textColor,
    this.textAlign,
    this.fontStyle,
    this.fontWeight,
    this.fontFamily,
    this.border_radius,
    this.icon1_color,
    this.icon1_size = 0,
    this.icon2_size = 0,
    this.icon2_color,
    this.blur_radius,
    this.BorderColor,
    this.boxshadowcolor,
    this.ContainerColor,
    this.icon1,
    this.icon2,
    this.offsetdx,
    this.offsetdy,
    this.spread_radius,
    this.pad_val_all_wrap_icon,
    this.pad_val_all_wrap_text,
    this.pad_val_bottom_wrap_icon,
    this.pad_val_bottom_wrap_text,
    this.pad_val_l_wrap_icon,
    this.pad_val_l_wrap_text,
    this.pad_val_r_wrap_icon,
    this.pad_val_r_wrap_text,
    this.pad_val_top_wrap_icon,
    this.pad_val_top_wrap_text,
    this.opacity = 0,
  });
}

class TextFieldParameters {
  final int maxLength;
  final bool maxLengthEnforced;
  final bool obscureText;
  final IconData prefixIcon;
  final IconData suffixIcon;
  final double cursorWidth;
  final double cursorHeight;
  final double borderRadius;
  final Color cursorColor;
  final bool filled;
  final Color borderColor;
  final Color fillColor;
  final String hintText;
  final String labelText;
  final Color iconColor;
  final Color textColor;
  final bool showCursor;
  final String payloadName;
  final Color focusedBorderColor;
  final Color enabledBorderColor;
  final double focusedBorderWidth;
  final double enabledBorderWidth;
  final TextEditingController controller;
  final double textFontSize;
  final String fontFamily;
  final FontWeight fontWeight;
  final FontStyle fontStyle;

  TextFieldParameters(
      {this.cursorColor,
      this.cursorHeight,
      this.cursorWidth,
      this.fillColor,
      this.filled,
      this.hintText,
      this.labelText,
      this.maxLength,
      this.maxLengthEnforced,
      this.obscureText,
      this.prefixIcon,
      this.suffixIcon,
      this.borderRadius,
      this.borderColor,
      this.iconColor,
      this.textColor,
      this.showCursor,
      this.payloadName,
      this.controller,
      this.focusedBorderColor,
      this.enabledBorderColor,
      this.focusedBorderWidth,
      this.enabledBorderWidth,
      this.textFontSize,
      this.fontFamily,
      this.fontWeight,
      this.fontStyle,
      });
}

///Widget Class
class IconButtonParameters {
  ///parameter
  Color color;

  ///parameter
  IconData icon;

  ///parameter
  double iconSize;

  ///parameter
  Color focusColor;

  ///parameter
  Color hoverColor;

  ///parameter
  Color splashColor;

  ///parameter
  Color highlightColor;

  ///parameter
  Color disabledColor;

  ///parameter
  AlignmentGeometry alignment;

  ///parameter
  bool autofocus;

  ///parameter
  String tooltip;

  IconButtonParameters(
      {this.iconSize,
      this.icon,
      this.color,
      this.disabledColor,
      this.hoverColor,
      this.focusColor,
      this.splashColor,
      this.highlightColor,
      this.alignment,
      this.autofocus,
      this.tooltip});
}

///Widget Class
class Floatingactionbuttonparam {
  @required

  ///parameter
  Widget child;

  ///parameter
  Color backgroundColor;

  ///parameter
  Color foregroundColor;

  ///parameter
  bool isExtended;

  ///parameter
  ShapeBorder shape;

  ///parameter
  Color hoverColor;

  ///parameter
  Color splashColor;

  ///parameter
  Object heroTag;

  ///parameter
  bool autofocus;

  ///parameter
  double elevation;

  ///parameter
  double hoverElevation;

  ///parameter
  double highlightElevation;

  ///parameter
  double focusElevation;

  ///parameter
  double disabledElevation;

  ///parameter
  FocusNode focusNode;

  ///parameter
  Color focusColor;

  ///parameter
  bool mini;

  ///parameter
  String tooltip;

  ///parameter
  void Function(bool) onPressed;

  Floatingactionbuttonparam(
      {this.backgroundColor,
      this.foregroundColor,
      this.isExtended = false,
      this.shape,
      this.hoverColor,
      this.splashColor,
      this.heroTag,
      this.focusNode,
      this.autofocus,
      this.child,
      this.focusColor,
      this.highlightElevation,
      this.elevation,
      this.mini,
      this.hoverElevation,
      this.focusElevation,
      this.disabledElevation,
      this.onPressed,
      this.tooltip});
}

///Widget Class
class Outlinebuttonparam {
  @required

  ///parameter
  Widget child;

  ///parameter
  BorderSide borderSide;

  ///parameter
  Color color;

  ///parameter
  ShapeBorder shape;

  ///parameter
  Color textColor;

  ///parameter
  Color disabledTextColor;

  ///parameter
  Color disabledBorderColor;

  ///parameter
  Color highlightColor;

  ///parameter
  Color hoverColor;

  ///parameter
  Color splashColor;

  ///parameter
  Color borderColor;

  ///parameter
  Color highlightedBorderColor;

  ///parameter
  Color focusColor;

  ///parameter
  double borderWidth;

  ///parameter
  BorderStyle borderStyle;

  ///parameter
  double width;

  ///parameter
  double height;

  ///parameter
  bool autofocus;

  ///parameter
  ButtonTextTheme textTheme;

  ///parameter
  FocusNode focusNode;

  Outlinebuttonparam(
      {this.borderSide,
      this.shape,
      this.textColor,
      this.hoverColor,
      this.highlightColor,
      this.focusColor,
      this.color,
      this.splashColor,
      this.borderColor,
      this.borderStyle,
      this.borderWidth,
      this.height,
      this.width,
      this.child,
      this.autofocus,
      this.focusNode,
      this.disabledTextColor,
      this.highlightedBorderColor,
      this.disabledBorderColor,
      this.textTheme});
}

///Widget Class
class DatePickerParameters {
  ///parameter
  int startMonth;

  ///parameter
  int startYear;

  ///parameter
  int endMonth;

  ///parameter
  int endYear;

  ///parameter
  int initialMonth;

  ///parameter
  int initialYear;

  ///parameter
  Color headerColor;

  ///parameter
  Color bodybgColor;

  ///parameter
  String confirmText;

  ///parameter
  String cancelText;

  ///parameter
  String hintText;

  ///parameter
  TextStyle hintTextStyle;

  ///parameter
  TextStyle buttonTextStyle;

  ///parameter
  TextStyle dayTextStyle;

  ///parameter
  TextStyle monthTextStyle;

  ///parameter
  TextStyle selectedDateStyle;

  ///parameter
  Color onHeaderColor;

  ///parameter
  Color onBodyColor;

  DatePickerParameters(
      {this.startMonth,
      this.startYear,
      this.endMonth,
      this.endYear,
      this.headerColor,
      this.bodybgColor,
      this.initialMonth,
      this.initialYear,
      this.hintText,
      this.cancelText,
      this.confirmText,
      this.buttonTextStyle,
      this.dayTextStyle,
      this.hintTextStyle,
      this.monthTextStyle,
      this.onBodyColor,
      this.onHeaderColor,
      this.selectedDateStyle});
}

///Widget Class
class TimePickerParameters {
  ///parameter
  Color headerColor;

  ///parameter
  Color selectColor;

  ///parameter
  Color bodybgColor;

  ///parameter
  Color timeColor;

  ///parameter
  Color buttonText;

  ///parameter
  String fontFamily;

  ///parameter
  double timeSize;

  ///parameter
  FontWeight fontWeight;

  TimePickerParameters({
    this.headerColor,
    this.bodybgColor,
    this.fontFamily,
    this.fontWeight,
    this.timeColor,
    this.selectColor,
    this.buttonText,
    this.timeSize,
  });
}

///Widget Class
class DrawerListItems {
  Widget leading;
  Widget title;

  DrawerListItems(this.leading, this.title);
}

///Widget Class
class DrawerHeaderParameters {
  ///parameter
  String imageType;

  ///parameter
  String imagepath;

  ///parameter
  String title;

  ///parameter
  String subtitle;

  ///parameter
  String fontFamily;

  ///parameter
  FontWeight fontWeight;

  ///parameter
  double fontSize;

  ///parameter
  Color fontColor;

  ///parameter
  Color headerColor;

  ///parameter
  Color listbgColor;

  DrawerHeaderParameters(
      {this.fontFamily,
      this.imageType,
      this.imagepath,
      this.title,
      this.subtitle,
      this.fontColor,
      this.fontWeight,
      this.fontSize,
      this.headerColor,
      this.listbgColor});
}

///Widget Class
class CarouselList {
  @required

  ///parameter
  Widget widget;
  CarouselList({
    this.widget,
  });
}

///Widget Class
class CarouselParameters {
  ///parameter
  double height;

  ///parameter
  double width;

  ///parameter
  double childAspectRatio;
  CarouselParameters({this.height, this.width, this.childAspectRatio});
}

///Widget Class
class GrantsData {
  ///parameter
  final String year;

  ///parameter
  final int grants;

  ///parameter
  final Color mColor;

  GrantsData(this.year, this.grants, this.mColor);
}

///Widget Class
class ScatterChartClass {
  ///parameter
  final String datalabel;

  ///parameter
  final int xValue;

  ///parameter
  final double yPercentage;

  ///parameter
  final double radius;

  ///parameter
  final Color color;

  ScatterChartClass(
      this.datalabel, this.xValue, this.yPercentage, this.radius, this.color);
}

class Series {
  final String year;
  final int subscribers;
  final charts.Color color;

  Series({this.year, this.subscribers, this.color});
}

class PaymentGatewayParams {
  final String amount;
  final Function() onSuccess;
  final Function() onFailure;
  final double paddingTop;
  final double paddingBottom;
  final double paddingLeft;
  final double paddingRight;
  final Alignment textAlign;
  final Color bttnColor;
  final double borderRadius;
  final IconData iconData;
  final Color iconColor;
  final String key;
  final String platformName;
  final String platformDescription;
  final String contactNumber;
  final String contactEmail;
  final double iconSize;
  final double fontSize;
  final String paymentText;
  final Color  paymentTextColor;

  PaymentGatewayParams(
      {this.amount,
        this.onFailure,
        this.onSuccess,
        this.bttnColor,
        this.borderRadius,
        this.key,
        this.platformName,
        this.platformDescription,
        this.contactNumber,
        this.contactEmail,
        this.iconData,
        this.iconColor,
        this.iconSize,
        this.fontSize,
        this.paymentText,
        this.paymentTextColor,
        this.paddingTop,
        this.paddingBottom,
        this.paddingLeft,
        this.paddingRight,
        this.textAlign});
}

class FeedBackForm{
  final String postUrl;
  final String rattingBarType;
  final String instaUrl;
  final String facebookUrl;
  final String twitterUrl;
  final Color submitButtonColor;
  final Color sendIconColor;
  final String dialogMessage;
  final Color dialogBackgroundColor;
  final Color dialogIndiactorTextColor;
  final Color rattingBarStarColor;
  FeedBackForm({this.postUrl,this.rattingBarType, this.instaUrl, this.facebookUrl, this.twitterUrl, this.submitButtonColor, this.sendIconColor, this.dialogMessage, this.dialogBackgroundColor, this.dialogIndiactorTextColor, this.rattingBarStarColor});
}

class Carouselparams{
  final String image1;
  final String image2;
  final String image3;
  final String image4;
  final String image5;
  final String image6;
  final Color dotColor;
  final double imageBorderRadius;
  final double containerHeight;
  Carouselparams({this.image1, this.image2, this.image3, this.image4, this.image5,this.image6,this.dotColor, this.imageBorderRadius, this.containerHeight});
}

class CustomListingParam {
  String imgUrl;
  double imgHeight;
  String title;
  double titlefontSize;
  String titlefontFamily;
  Color titlefontColor;
  String subTitle;
  double subTitlefontSize;
  String subTitlefontFamily;
  Color subTitlefontColor;
  IconData icon;
  Color iconColor;
  double iconsize;
  String subBtnText;
  double subBtnHeight;
  double subBtnfontSize;
  String subBtnfontFamily;
  Color subBtnfontColor;
  Color subBtnborderColor;

  CustomListingParam(
      {this.imgUrl,
        this.imgHeight,
        this.title,
        this.titlefontSize,
        this.titlefontFamily,
        this.titlefontColor,
        this.subTitle,
        this.subTitlefontSize,
        this.subTitlefontColor,
        this.subTitlefontFamily,
        this.icon,
        this.iconColor,
        this.iconsize,
        this.subBtnHeight,
        this.subBtnText,
        this.subBtnfontSize,
        this.subBtnfontFamily,
        this.subBtnfontColor,
        this.subBtnborderColor});
}

class VerificationParam {
  int OtpLength;
  final Function() onSuccess;
  final Function() onFailure;
  String ImageUrl;
  double imgHeight;
  String title;
  double titlefontSize;
  String titlefontFamily;
  Color titlefontColor;
  FontWeight titlefontWeight;
  String msg;
  double msgfontSize;
  String msgfontFamily;
  Color msgfontColor;
  String btnText;
  String waitMsg;
  double btnfontSize;
  double btnHeight;
  double btnBorderRadius;
  double btnPaddingLeft;
  double btnPaddingTop;
  double btnPaddingRight;
  double btnPaddingBottom;
  double btnBorderWidth;
  String btnfontFamily;
  Color btnfontColor;
  Color btnBorderColor;
  Color btnColor;
  String postAPI;
  String payloadName;
  String responseKey;
  Color dialogBackgroundColor;
  Color dialogIndiactorTextColor;

  VerificationParam(
      {this.OtpLength,
        this.onSuccess,
        this.onFailure,
        this.ImageUrl,
        this.imgHeight,
        this.waitMsg,
        this.title,
        this.titlefontSize,
        this.titlefontFamily,
        this.titlefontColor,
        this.titlefontWeight,
        this.msg,
        this.msgfontColor,
        this.msgfontFamily,
        this.msgfontSize,
        this.btnText,
        this.btnfontSize,
        this.btnfontFamily,
        this.btnfontColor,
        this.btnColor,
        this.btnHeight,
        this.btnPaddingLeft,
        this.btnPaddingTop,
        this.btnPaddingRight,
        this.btnPaddingBottom,
        this.btnBorderRadius,
        this.btnBorderWidth,
        this.btnBorderColor,
        this.payloadName,
        this.responseKey,
        this.dialogBackgroundColor,
        this.dialogIndiactorTextColor,
        this.postAPI});
}

class DocumentUploadParamsWidget {

  String buttonText;
  double fontSize;
  FontWeight fontWeight;
  Color textColor;
  double height;
  double minWidth;
  double elevation;
  Color buttonColor;
  double borderRadius;
  Function() onPressed;
  bool showSelectedFileNames;
  String apiUrl;
  String uploadKey;

  DocumentUploadParamsWidget(
  {
    this.buttonText,
    this.fontSize,
    this.fontWeight,
    this.textColor,
    this.height,
    this.minWidth,
    this.elevation,
    this.buttonColor,
    this.borderRadius,
    this.onPressed,
    this.showSelectedFileNames,
    this.apiUrl,
    this.uploadKey,
  });

}